package io.zipcoder.polymorphism;

import java.util.ArrayList;
import java.util.InputMismatchException;
import java.util.Scanner;

/**
 * Created by leon on 11/6/17.
 * Create a Pet class, and a subclass for each type of pet that you want your program to support. Your classes should follow the following requirements:
 * <p>
 * You must support at least three types of pets.
 * Dog must be one of the types you support.
 * Cat must be one of the types you support.
 * The Pet class must have a speak method that each subclass overrides.
 * The Pet class must have a name field with setters and getters.
 */
public class MainApplication {

    static Scanner sc = new Scanner(System.in);
    static int numberOfPets;
    static ArrayList<Pet> pets = new ArrayList<Pet>();

    public static int getNumOfPets() {
        System.out.println("how many pets do you have?");
        try {
            numberOfPets = sc.nextInt();
        } catch (InputMismatchException e) {
            System.out.println("Not a number. Please enter again.");
            sc.nextLine();
            numberOfPets = getNumOfPets();
        }
        return numberOfPets;
    }

    public static ArrayList<Pet> getListOfPets() {

        for (int i = 0; i < numberOfPets; i++) {
            System.out.println("what kind of pet are they?");
            sc.nextLine();
            String petType = sc.nextLine();
            System.out.println("What is their name?");
            String name = sc.nextLine();
            System.out.println("What is their age?");
            int age = sc.nextInt();
            if (petType.equalsIgnoreCase("dog")) {
                pets.add(new Dog(name, age));
            } else if (petType.equalsIgnoreCase("cat")) {
                pets.add(new Cat(name, age));
            } else if (petType.equalsIgnoreCase("fish")) {
                pets.add(new Fish(name, age));
            } else {
                System.out.println("Error invalid pet. Aborting");
                System.exit(0);
            }

        }
        return pets;
    }

    public static void displaySpeak () {
        for(Pet pet: pets ) {
            System.out.println("Your pet is a " + pet.getClass().getSimpleName() + " whose name is " +
            pet.getName() + " whose age is " + pet.getAge() + " who says " + pet.speak());
//            System.out.println(pet.getClass());
//            System.out.println(pet.getClass().getSimpleName());
        }


    }

    public static void main(String[] args) {
        getNumOfPets();
        getListOfPets();
        displaySpeak();


//
//            Cat cat = new Cat("Brian", 5);
//            Dog dog = new Dog();
//            pets.add(cat);
//            pets.add(dog);
//            //for each pet of type Pet in the pets arraylist do some action
//            for (Pet pet: pets) {
//                System.out.println(pet.getClass().getSimpleName());
//            }
//
//            for (int i =0; i < pets.size(); i++) {
//                System.out.println(pets.get(i).getName());
//            }
    }


}



